-- Dclaration avance de fonctions locales
local single_page, read_file, urldecode, read_directory

-- Boucle principale du programme
local function main_server(root, port)
  local socket = require 'socket'
  root = root or "/var/www"
  local server = socket.bind("0.0.0.0", port or 8080)
  while true do
    local client = server:accept()
    local res, err = xpcall(single_page, 
      debug.traceback, client, root)
    if not res then
      -- Si une erreur s'est produite, renvoyer code HTTP 500
      client:send"HTTP/1.0 500 Internal Server Error\r\n\r\n"
      client:send("OUPS! Il doit y avoir un bogue :\r\n"..err)
    end
    client:close()
  end
end

-- Fonction appele pour chaque requte  servir
function single_page(client, root)
  -- Lit et interprte la 1re ligne de la requte
  local line = assert(client:receive())
  local verb, path, proto = 
    assert(line:match("([A-Z]+)%s+(%S+)%s+(HTTP.+)"))
  -- Dcode les lignes d'en-tte de la requte
  local request = {}
  repeat
    line = assert(client:receive())
    local param, value = line:match("(%S-)%s*:%s*(.*)")
    if param then
      request[param] = value
    end
  until line == ""
  -- Normalise le chemin du fichier, ajoutant v. "/index.html"
  path = root .. urldecode(path)
  path = path:gsub("/$", "/index.html")
  -- Lit le fichier demand et l'envoie avec le code HTTP 200
  local data = read_file(path)
  client:send(("HTTP/1.0 200 OK\r\nContent-Length: %d\r\n\z
    Server: Lua\r\n\r\n") : format(#data))
  client:send(data)
end

-- Dcode caractres spciaux dans l'URL (+ et %XX)
function urldecode(str)
  return str -- sera crite  l'tape 6
end

-- Lit un fichier et retourne son contenu dans une chane
function read_file(path)
  local f = assert(io.open(path, 'rb'))
  local content = f:read("*a")
  f:close()
  return content
end

-- Lance le serveur avec les arguments passs au script
main_server(...)
